module intf.
import obj parser.

type start            o.
doc  start "top level predicate".

type display          o.
doc  display  "      of the current set of classes".
type display_list     list o   -> o.

type dec              list o   -> o.
doc  dec "decl. of the classes". 

type parse            list fo -> list fo -> int -> o.
doc  parse  "parsing of  interactive commands".
type parse_class_list list o   -> o.

type write_classes o.
doc  write_classes "write the names of loaded classes".

% Auxiliary interactive commands" 
type s  list fo.
doc  s  "the current state".

type l  list fo.
doc  l  "current list of classes". 

type q list fo.
doc  q "quit".

type w list fo.

type n string  -> list fo.
doc  n "new class ".

type c int -> string -> list fo -> list fo.
doc c  "call (id Id) Class Pars".

start:-
 dec L, 
 parse_class_list L.

parse_class_list nil:-
  inter nil 0.

parse_class_list (Class::Classes):-
 parse_class      Class   ClassFo, 
 ClassFo => parse_class_list Classes.
 
inter  S N:-
 (read (Commands \ (parse S Commands N))).

write_classes:-
  classdef Name Def,
  write Name, 
  write " ",
  fail.

write_classes:-nl.

parse S q N:-
  write S.

parse S l N:-
  write_classes,
  inter S N.

parse  S  s N:-
  write S,
  nl,
  inter S N.
  
parse  S  w N:-
  execute ((new "buffer" Id)::(call Id "put" ((istr "john")::nil))::nil) 
  S N.

parse S (n Class) N:-
 execute ((new Class Id)::nil) S  N.


parse S (c Id Meth Par) N:-
 execute ((call (id Id) Meth Par)::nil) S  N.

parse    S Commands N:-
 execute Commands S N.
  
display:-
 dec L, 
 display_list L.

display_list (Class::Classes):-
 parse_class  Class ClassFo, 
 write ClassFo,
 nl,nl,
 display_list Classes.

display_list nil.
