module obj.
import objsign lists.

%%%%%%%% June 05, 18:47    %%%%%%%%%%%%%%%%%%%%%%%
%%% (class Name id\(obj id Str)).

type merge_structs list fo -> list fo -> list fo -> o.

merge_structs ((meth N M)::InStr) Str ((meth N M)::OutStr) :-
 memb_and_rest (meth N K) Str Str1,!,
 merge_structs InStr Str1 OutStr.

merge_structs ((meth N M)::InStr) Str ((meth N M)::OutStr) :-
 merge_structs InStr Str OutStr.

merge_structs ((var N V)::InStr) Str ((var N V)::OutStr) :-
 memb_and_rest (var N W) Str Str1,!,
 merge_structs InStr Str1 OutStr.

merge_structs ((var N V)::InStr) Str ((var N V)::OutStr) :-
 merge_structs InStr Str OutStr.

merge_structs nil Str Str.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
type inter   list fo -> int -> o.
doc  inter   "State     N".

type execute  list fo     ->  list fo  ->  int     -> o . 
doc  execute "Messages        State        CurId".

type climb_hierarchy  ref -> string       -> fo ->  list fo  -> list fo -> int   -> o.
doc  climb_hierarchy  "Id    Superclass     InObj  Messages    Objects    CurId". 

type solve_hierarchy   fo -> fo -> ref -> list fo  -> list fo -> int   -> o.
doc  solve_hierarchy  "Obj   Obj1  Id     Messages    Objects    CurId". 

solve_hierarchy (fa_str Obj) Obj1 Id Ms  Objects M:-
 pi x \ solve_hierarchy (Obj x) Obj1 Id Ms Objects M.
 
solve_hierarchy (obj Id Str) (fa_str Obj1) Id Ms Objects M:-
 pi x \ solve_hierarchy (obj Id Str) (Obj1 x) Id Ms Objects M.

solve_hierarchy (obj Id Str) (obj Id Str1) Id Ms Objects M:-
 merge_structs Str Str1 OutStr,
 execute Ms ((obj Id OutStr)::Objects) M.

type solve_hierarchy1   fo -> fo -> string -> ref -> list fo  -> list fo -> int   -> o.
doc  solve_hierarchy1  "Obj   Obj1  Super     Id     Messages    Objects    CurId". 

solve_hierarchy1 (fa_str Obj) Obj1 Super Id Ms  Objects M:-
 pi x \ solve_hierarchy1 (Obj x) Obj1 Super N Ms Objects M.
 
solve_hierarchy1 (obj Id Str) (fa_str Obj1) Super Id Ms Objects M:-
 pi x \ solve_hierarchy1 (obj Id Str) (Obj1 x) Super Id Ms Objects M.

solve_hierarchy1 (obj Id Str) (obj Id Str1) Super Id Ms Objects M:-
 merge_structs Str Str1 OutStr,
 climb_hierarchy Id Super (obj Id OutStr) Ms Objects M.

climb_hierarchy Id Class Obj Ms Objects M:- 
 classdef Class Def,
 (Def Id) = Obj1,
 solve_hierarchy Obj Obj1 Id Ms Objects M.
  
climb_hierarchy Id Class Obj Ms Objects M:- 
 subclassdef SuperClass Class Def,
 (Def Id) = Obj1,
 solve_hierarchy1 Obj Obj1 SuperClass Id Ms Objects M.
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

type modify_structure  list fo -> list fo -> list fo -> o.
doc  modify_structure   "Updates   InStr      OutStr".

modify_structure nil OutStr OutStr.

modify_structure ((get Name Body)::Updates) InStr OutStr :-
 memb (meth Name Body) InStr,
 modify_structure Updates InStr OutStr.    

modify_structure ((put Name NewBody)::Updates) InStr OutStr :-
 memb_and_rest   (meth Name OldBody) InStr InStr1,
 modify_structure Updates ((meth Name NewBody)::InStr1) OutStr.

modify_structure ((get Name Value)::Updates) InStr OutStr :-
 memb (var Name Value) InStr,
 modify_structure Updates InStr OutStr.    

modify_structure ((put Name NewValue)::Updates) InStr OutStr :-
 memb_and_rest   (var Name OldValue) InStr InStr1,
 modify_structure Updates ((var Name NewValue)::InStr1) OutStr.

modify_structure ((addmeth Name Body)::Updates) InStr OutStr :-
 modify_structure Updates ((meth Name Body)::InStr) OutStr.

modify_structure ((killmeth Name)::Updates) InStr OutStr :-
 memb_and_rest   (meth Name Body) InStr InStr1,
 modify_structure Updates InStr1 OutStr.

% to process local declarations:

type solvelocal list fo -> list fo -> list fo -> int -> o.
doc  solvelocal "local Body   Ops Objects  N ".

solvelocal (local Body) Ops  Objects N:-
  pi x \ (solvelocal (Body x) Ops Objects N).

solvelocal  (A::L)  Ops Objects N:-
  append    (A::L)  Ops   NewOps,
  execute   NewOps Objects N.
 
solvelocal  nil     Ops Objects N:-
  execute   Ops     Objects N.

type parquant ref -> fo -> list fo -> list fo -> list fo -> list fo ->  int -> o.
doc  parquant "Id Body Pars       Ops        Str        Objects      M".

parquant  Id  (fa Body)     Pars Ops Str Objects M:-
 parquant Id  (Body Y)      Pars Ops Str Objects M. 

parquant  Id  (fa_fo Body)  Pars Ops Str Objects M:-
 parquant Id  (Body Y)      Pars Ops Str Objects M.

parquant  Id  (fa_int Body) Pars Ops Str Objects M:-
 parquant Id  (Body Y)      Pars Ops Str Objects M. 

parquant  Id  (fa_ref Body) Pars Ops Str Objects M:-
 parquant Id  (Body Y)      Pars Ops Str Objects M. 
 
parquant  Id  (fa_str Body) Pars Ops Str Objects M:-
 parquant Id  (Body Y)      Pars Ops Str Objects M. 

parquant  Id  (fa_bool Body) Pars Ops Str Objects M:-
 parquant Id  (Body Y)       Pars Ops Str Objects M.

parquant  Id  (C & D)       Pars Ops Str Objects M:-
 parquant Id  C             Pars Ops Str Objects M.

parquant  Id  (C & D)       Pars Ops Str Objects M:-
 parquant Id  D             Pars Ops Str Objects M.

parquant  Id  (pars_updates_body Pars Updates Body) Pars Ops InStr Objects M:-
 modify_structure  Updates InStr OutStr, 
% without local dec of type (list fo).
% append            Body    Ops   NewOps,
% execute           NewOps ((obj Id OutStr)::Objects) M.
%
 solvelocal         Body    Ops ((obj Id OutStr)::Objects) M.   

type 	solvequant	 fo -> list fo -> list fo -> int -> o.
doc	solvequant	"Obj   Messages    Objects   CurrId".

solvequant   (obj Id Str) Ms Objects N :-
 execute Ms ((obj Id Str)::Objects) N.

solvequant (fa_str Obj) Ms Objects N:-
 pi y \(solvequant (Obj y) Ms Objects N).

execute ((newl Class Id)::Ms) Objects N:-
 classdef Class Def,
 Def1 = (Def Id),
 write Def1,
 solvequant (Def Id) Ms Objects N.
 
execute ((newl Class Id)::Ms) Objects N :-
 subclassdef        SuperClass Class   Def,
 climb_hierarchy Id SuperClass (Def Id) Ms Objects N.

execute ((new Class (id N))::Ms) Objects N :-
 classdef  Class Def,
 M is N + 1,
 solvequant (Def (id N)) Ms Objects M.

execute ((new Class (id N))::Ms) Objects N :-
 subclassdef        SuperClass Class   Def,
 M is N + 1,
 climb_hierarchy (id N) SuperClass (Def (id N)) Ms Objects M. 

execute   ((kill Id)::Ops)  Objects M:-
 memb_and_rest (obj Id Str) Objects Rest,
 execute            Ops  Rest    M. 

execute  ((call Id Meth Pars)::Ops) InObjects M:-
 memb_and_rest   (obj Id Str)       InObjects OutObjects,
 memb (meth Meth Body)  Str,
 parquant Id Body Pars Ops Str OutObjects M.

execute  ((sys Goal)::Ops) Objects M:-
 Goal,
 execute Ops Objects M. 

execute nil Objects N:-
 inter Objects N.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

type go list fo -> o. 

go L:-
 execute L nil 0.











